#include <stdio.h>
#include <stdlib.h>

int sum(int* nums, int n) {
    int total = 0, i;
    for (i = 0; i < n; i++) {
        total += nums[i];
    }
    return total;
}

void print_time(int minutes) {
    /* count down the hours needed */
    int hours = 0;
    while (minutes >= 60) {
        hours++;
        minutes -= 60;
    }

    /* print the hours */
    if (hours) {
        printf("%d hour%s", hours, hours > 1 ? "s" : "");
    }

    if (minutes) {
        if (hours) printf(" and ");
        printf("%d minute%s", minutes, minutes > 1 ? "s" : "");
    }
}

int min_wait(int* waits, int n) {
    /* the min wait time is just 10 minutes * (N - 1) */
    return 10 * (n - 1);
}

int max_wait(int* waits, int n) {
    /* the maximum wait time is the sum of all waits except the first, plus
     * the minimum time */
    return sum(waits + 1, n - 1) * 60 + min_wait(waits, n);
}

int main() {
    int beacons, *waits, i;

    /* grab the input */
    scanf("%d", &beacons);
    waits = malloc(beacons * sizeof(int));
    for (i = 0; i < beacons; i++) {
        scanf("%d", &waits[i]);
    }

    printf("The minimum time is ");
    print_time(min_wait(waits, beacons));
    printf(".\nThe maximum time is ");
    print_time(max_wait(waits, beacons));
    printf(".\n");

    free(waits);
    return 0;
}

