#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* max size of one name */
#define STR_SIZE 100

/* find the index of the hobbit from a list */
int find(char* hobbit, char** shire, int n) {
    int i;

    for (i = 0; i < n; i++) {
        if (strcmp(hobbit, shire[i]) == 0) {
            return i;
        }
    }

    return -1;
}

/* function which loops through each of the N choose 2 pairs of hobbits
 * and checks if the two are in different orders, returning the number
 * that are different */
int check_pairs(char** frodos, char** sams, int n) {
    int i, j, out = 0;

    /* loop through each pair of hobbits */
    for (i = 0; i < n; i++) {
        for (j = i+1; j < n; j++) {
            char* a = frodos[i];
            char* b = frodos[j];

            /* get the index of a and b in each */
            int af = find(a, frodos, n);
            int as = find(a, sams, n);
            int bf = find(b, frodos, n);
            int bs = find(b, sams, n);

            /* if we subtract, the signs tell us order
             * if signs are different, order is different */
            if (((af - bf) < 0) && ((as - bs) > 0)) {
                out++;
            }
        }
    }

    return out;
}

int main() {
    int n, i;

    /* read all of the input */
    scanf("%d\n", &n);
    char** frodos = malloc(n * sizeof(char*));
    char** sams = malloc(n * sizeof(char*));
    for (i = 0; i < n; i++) {
        frodos[i] = malloc(STR_SIZE * sizeof(char));
        scanf("%s", frodos[i]);
    }
    for (i = 0; i < n; i++) {
        sams[i] = malloc(STR_SIZE * sizeof(char));
        scanf("%s", sams[i]);
    }

    /* print the number of differently ordered pairs */
    printf("%d\n", check_pairs(frodos, sams, n));

    /* free memory */
    for (i = 0; i < n; i++) {
        free(sams[i]);
        free(frodos[i]);
    }
    free(sams);
    free(frodos);

    return 0;
}

