#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct {
    char label;
    char links[256];
    int lit;
} Cavern;

/* find a cavern in the list of caverns by label */
Cavern* find_cavern(Cavern* list, char label, int n) {
    int i;
    for (i = 0; i < n; i++) {
        if (list[i].label == label) {
            return &list[i];
        }
    } 
    return NULL;
}

/* simulate balgar and the goblins romp through the labyrinth */
void simulate(Cavern* caverns, int n, Cavern* balgar, Cavern* goblin, int k, int step, int first) {
    int i;

    /* find out which cavern the goblin goes into next */
    Cavern* goblin_next = NULL;
    for (i = 0; i < strlen(goblin->links); i++) {
        /* get the cavern of this link */
        Cavern* link = find_cavern(caverns, goblin->links[i], n);

        /* if it's not lit, and not balgar's, use it */
        if (!link->lit && link != balgar) {
            goblin_next = link;
            break;
        }
    }

    /* if the goblin had nowhere to run, he dead */
    if (goblin_next == NULL) {
        printf("\n%c\n", goblin->label);
        return;
    }

    /* check if balgar leaves a torch here */
    if (step == k) {
        /* to avoid trailing spaces, we do it BEFORE */
        if (first) {
            first = 0;
        } else {
            printf(" ");
        }
        balgar->lit = 1;
        printf("%c", balgar->label);
        step = 1;
    } else {
        step++;
    }

    /* move to the next step: balgar goes where goblin is, goblin goes to next room */
    simulate(caverns, n, goblin, goblin_next, k, step, first);
}

int main() {
    int n, i;

    /* find the number of caverns and allocate them */
    scanf("%d\n", &n);
    Cavern* caverns = malloc(n * sizeof(Cavern));

    /* read in the Caverns */
    for (i = 0; i < n; i++) {
        char line[256];
        scanf("%s\n", line);
        caverns[i].label = line[0];
        strcpy(caverns[i].links, line + 1);
        caverns[i].lit = 0;
    }

    /* read the other parameters */
    char goblin, balgar;
    int k;
    scanf("%c\n", &goblin);
    scanf("%c\n", &balgar);
    scanf("%d\n", &k);

    /* simulate the labyrinth */
    simulate(caverns, n, find_cavern(caverns, balgar, n),
            find_cavern(caverns, goblin, n), k, 0, 1);

    free(caverns);
    return 0;
}

